
function CreateAliasWin()

	if tAlias ~= nil then

		local NumAliases = #tAlias;

		wAliasParent:SetWidth(25*NumAliases);

		local farRight = bOpen:GetLeft() + bOpen:GetWidth() + wAliasParent:GetWidth();

		if farRight > Turbine.UI.Display.GetWidth() then

			wAliasParent:SetLeft(bOpen:GetLeft()-wAliasParent:GetWidth());

		else

			wAliasParent:SetLeft(bOpen:GetLeft()+bOpen:GetWidth());

		end

		qsAlias = {};

		for i=1, NumAliases, 1 do

			qsAlias[i] = Turbine.UI.Lotro.Quickslot();
			qsAlias[i]:SetParent(wAliasParent);
			qsAlias[i]:SetSize(23,23);
			qsAlias[i]:SetPosition((i-1)*24,0);
			qsAlias[i]:SetVisible(true);
			qsAlias[i]:SetUseOnRightClick(false);


			local tempAliasSC = tAlias[i].shortcut;
			local tempAliasText = tAlias[i].text;

			qsAlias[i]:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, tempAliasSC));

			qsAlias[i].MouseClick = function (sender, args)

				if (args.Button == Turbine.UI.MouseButton.Right) then

					createDeleteMenu(i);

				end

			end


			qsAlias[i].MouseLeave = function (sender, args)

				wAliasPreview:SetVisible(false);

			end


			qsAlias[i].MouseEnter = function (sender, args)

				if tAlias[i] ~= nil then

					lAliasPreview:SetText(tAlias[i].text);
					AutoWidth(lAliasPreview);

					wAliasPreview:SetPosition(wAliasParent:GetLeft() + qsAlias[i]:GetLeft(),(wAliasParent:GetTop() - wAliasPreview:GetHeight() - 5));
					wAliasPreview:SetWidth(lAliasPreview:GetWidth()+10);

					wAliasPreview:SetVisible(true);

				end

			end

		end

	else

		wAliasParent:SetWidth(0);

	end

end


function saveAlias(alias,text)

	local NumAliases = 0;

	if tAlias ~= nil then

		NumAliases = #tAlias;

	end

	local alIndex = NumAliases + 1;

	tAlias[alIndex] =
		{
		["shortcut"] = tempChannel .. " " .. OutputSuper;
		["text"] = tempChannel .. " " .. OutputSuper;
		};

	Turbine.Shell.WriteLine("Saved Alias: " .. tempChannel .. " " .. OutputSuper);
	CreateAliasWin();

end


function deleteAlias(index)

	local bufferAlias = {}
	local NumAliases = #tAlias;

	for i=1, (index-1), 1 do

		bufferAlias[i] = tAlias[i];

	end

	for i=index+1, NumAliases, 1 do

		bufferAlias[i-1] = tAlias[i];

	end

	Turbine.Shell.WriteLine("Deleted Alias: " .. tAlias[index].shortcut);

	tAlias = {}
	tAlias = bufferAlias;

	CreateAliasWin();

end


function createDeleteMenu(index)

	-- Data storeage
	local MenuBackcolor = Turbine.UI.Color(0.0, 0.0, 0.0);

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();

	--local menuMaxHeight = (screenHeight / 2);
	local menuCurTop = 3;

	local lineHeight = 25; -- Height of each line in the menu.
	local linebuffer = 3;
	local menuWidth = 60;

	-------------------------------------------------------------------------
	-- Windows

	winAlDeleteMenuParent = Turbine.UI.Window();
	winAlDeleteMenuParent:SetBackColor(MenuBackcolor);
	winAlDeleteMenuParent:SetMouseVisible(true);
	winAlDeleteMenuParent:SetOpacity(0);
	winAlDeleteMenuParent:SetPosition(0,0);
	winAlDeleteMenuParent:SetSize(screenWidth,screenHeight);
	winAlDeleteMenuParent:SetVisible(true);
	winAlDeleteMenuParent:SetZOrder(198);

	winAlDeleteMenuBody = Turbine.UI.Window();
	winAlDeleteMenuBody:SetParent(winAlDeleteMenuParent);
	winAlDeleteMenuBody:SetBackColor(MenuBackcolor);
	winAlDeleteMenuBody:SetMouseVisible(true);
	winAlDeleteMenuBody:SetOpacity(0.8);
	winAlDeleteMenuBody:SetPosition(initX,initY);
	winAlDeleteMenuBody:SetVisible(true);
	winAlDeleteMenuBody:SetWidth(menuWidth);
	winAlDeleteMenuBody:SetHeight(lineHeight + (2 * linebuffer));
	winAlDeleteMenuBody:SetZOrder(199);

	winAlDeleteMenuItem = Turbine.UI.Control();
	winAlDeleteMenuItem:SetHeight(lineHeight);
	winAlDeleteMenuItem:SetLeft(linebuffer);
	winAlDeleteMenuItem:SetTop(menuCurTop);
	winAlDeleteMenuItem:SetWidth(menuWidth - (2 * linebuffer));
	winAlDeleteMenuItem:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0));
	winAlDeleteMenuItem:SetOpacity(1);
	winAlDeleteMenuItem:SetMouseVisible(true);
	winAlDeleteMenuItem:SetParent(winAlDeleteMenuBody);

	winAlDeleteMenuLabel = Turbine.UI.Label();
	winAlDeleteMenuLabel:SetParent(winAlDeleteMenuItem);
	winAlDeleteMenuLabel:SetHeight(lineHeight-8);
	winAlDeleteMenuLabel:SetLeft(5);
	winAlDeleteMenuLabel:SetTop(4);
	winAlDeleteMenuLabel:SetWidth(winAlDeleteMenuItem:GetWidth()-10);
	winAlDeleteMenuLabel:SetText("Delete");
	winAlDeleteMenuLabel:SetForeColor(Turbine.UI.Color(1,1,1));
	winAlDeleteMenuLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	winAlDeleteMenuLabel:SetMultiline(false);
	winAlDeleteMenuLabel:SetMouseVisible(false);


	------------------------------------------------------------------------------
	-- Mouse event handlers
	winAlDeleteMenuItem.MouseEnter = function(sender, args)

		winAlDeleteMenuItem:SetBackColor(Turbine.UI.Color(0.0, 0.3, 0.3));

	end


	winAlDeleteMenuItem.MouseLeave = function(sender, args)

		winAlDeleteMenuItem:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0));

	end


	winAlDeleteMenuItem.MouseClick = function(sender, args)

		-- Activate delete alias function
		deleteAlias(index);
		winAlDeleteMenuParent:SetVisible(false); -- Hide menu after click.

	end


	-- Click outside menu, close window.
	winAlDeleteMenuParent.MouseClick = function(sender, args)

		winAlDeleteMenuParent:SetVisible(false);
		wAliasParent:SetVisible(false);

	end


	winAlDeleteMenuBody.MouseEnter = function (sender, args)

		wAliasParent:SetVisible(true);

	end

end
